<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php
  
class Blog {   
	private $db;
	private $tools;
	private $months;
	private $arguments = array();
	
	public function __construct() {
		$this -> db = Core_Database::getInstance();
		
		$this -> tools = new Tools_Text;
		$this->L = Core_Language::getInstance();
		
		$this->months['ru']=array(1=>'Января',2=>'Февраля',3=>'Марта',4=>'Апреля',5=>'Мая',6=>'Июня',7=>'Июля',8=>'Августа',9=>'Сентября',10=>'Октября',11=>'Ноября',12=>'Декабря');
		$this->months['lv']=array(1=>'janvārī',2=>'februārī',3=>'martā',4=>'aprīlī',5=>'maijā',6=>'jūnijā',7=>'jūlijā',8=>'augustā',9=>'septembrī',10=>'oktobrī',11=>'novembrīs',12=>'decembrīs');
	
	}
	
    public function setArg($array = array() ) {
    
 
			$this->arguments[]='GROUP BY s.id';
			$this->arguments[]='ORDER BY date DESC';
			if(isset($array['limit'])){
    		
    				$this->arguments[]='LIMIT 0,'.$array['limit'];
    		}
    }
	
	public function getList() {
		$result = array();
		
		$and_sql = '';
		
		$current_lang = $this->L->getCurrentLanguage();
		$arguments =implode(' ',$this->arguments);
	
		$sql = "SELECT s.*,COUNT(v.page_id) as total_visits FROM blog_pages as s LEFT JOIN blog_visits as v ON v.page_id = s.id WHERE 1=1 ".$arguments." ";

		$res = $this -> db -> Exec($sql);
		$rows = $this -> db -> Count($res);
		if ($rows) {
			for ($i=0;$i<$rows;$i++) {
				$row = $this -> db -> fetch($res);
				
				if($row['status']==1)
					$row['status_name'] = $this->L->Str('active');
				elseif($row['status']==0)
					$row['status_name'] = $this->L->Str('not_active');
                
				$row['title_ru']=$row['title'];					
				$row['title_lv']=$this->L->StrT_lang('blog_pages','title', $row['id'],'','lv');
				$row['title_en']=$this->L->StrT_lang('blog_pages','title', $row['id'],'','en');
				
				$row['text_ru']=$row['text'];					
				$row['text_lv']=$this->L->StrT_lang('blog_pages','text', $row['id'],'','lv');
				$row['text_en']=$this->L->StrT_lang('blog_pages','text', $row['id'],'','en');
				
				$row['title'] = $row['title_'.$current_lang];
		        $row['text'] = $row['text_'.$current_lang];
		        $row['blog_image'] = '/images/blog_images/'.$row['image'];  		        
				
				
				$short_description = strip_tags(html_entity_decode($row['text']));
				
			
				
		  		$row['short_desc'] = strlen($short_description)>520 ?  mb_substr(strip_tags($short_description),0,520,'UTF8').'...' : $short_description;
		  		
		  		$row['link'] = '/blog/'.Tools_Text :: cleanString($row['title']).'/?blog_id='.$row['id'];												               			               						
				$result[] = $row;
			}	
		}
		return $result;
		
	}
	
	


	public function setStatus ($id,$status) {
	
		$status = (int) $status;
		$this -> db -> Exec("UPDATE blog_pages SET status = '".$status."' WHERE id = ".$id);
	}
	

	public function editItem($id,$array) {
	
		$L = Core_Language::getInstance();
		$title = $array['title']; 
		$descr = $array['text'];
		$status = isset($array['status']) ? $array['status'] : 0;
		
		
		
	
		if ($id) {
			$sql = "UPDATE blog_pages SET title = '".$title['ru']."', text='".$descr['ru']."', status='".$status."' WHERE id = ".$id;
		
			$this -> db -> Exec($sql);
			
	
		
		} else {
			$sql = "INSERT INTO blog_pages SET title='".$title['ru']."',text='".$descr['ru']."' , status=1, `date` = '".time()."' ";

			$this -> db -> Exec($sql);
			$id = $this->db->lastId();
			
			$L -> addText ('blog_pages', 'title', $id);
			$L -> addText ('blog_pages', 'text', $id);
							 		
		}
	
			
        foreach($descr as $lang_id =>$value) {
		
				$L ->addValue('blog_pages','text',$id,$lang_id,$value);
		    	$L ->addValue('blog_pages','title',$id,$lang_id,$title[$lang_id]);
		}
	
		
		return $id;
	}
	      
	
	public function addProduct ($id,$page_id) { 
	
	
		$sql = 'INSERT INTO seo_products(page_id,product_id) VALUES ("'.$page_id.'","'.$id.'")';	
	    $res = $this -> db -> Exec($sql);
	
	} 
	
	public function addCategory ($id,$page_id) { 
	
	
		$sql = 'INSERT INTO blog_categories (page_id,category_id) VALUES ("'.$page_id.'","'.$id.'")';	
	    $res = $this -> db -> Exec($sql);
	
	} 
	
	public function removeProduct ($id,$page_id) { 
	
		$sql = 'DELETE FROM blog_products WHERE  page_id = "'.$page_id.'" AND product_id = "'.$id.'" ';
	    $res = $this -> db -> Exec($sql);
	
	}
	
	public function removeCategory ($id,$page_id) { 
	
		$sql = 'DELETE FROM blog_categories WHERE  page_id = "'.$page_id.'" AND category_id = "'.$id.'" ';
	    $res = $this -> db -> Exec($sql);
	
	}
	
	public function deletePage ($page_id) { 
	
		if($page_id) {
		
		/*	$sql = 'DELETE FROM blog_categories WHERE  page_id = "'.$page_id.'"  ';
		    $res = $this -> db -> Exec($sql);*/
	    
		    $sql = 'DELETE FROM blog_products WHERE  page_id = "'.$page_id.'"  ';
		    $res = $this -> db -> Exec($sql);
		    
		    $sql = 'DELETE FROM blog_pages WHERE  id = "'.$page_id.'"  ';
		    $res = $this -> db -> Exec($sql);
		    
		    $sql = 'DELETE FROM blog_visits WHERE  page_id = "'.$page_id.'"  ';
		    $res = $this -> db -> Exec($sql);
	    }
	
	}
	
	
	
	public function addVisit ($page_id) { 
	
	
						                 
			$ip = Tools_Http::getIP();			                 	
			$sdate = explode('.',date('d.m.y',time())); 					                 
			$time_start =mktime(00,00,00, $sdate['1'] , $sdate['0'], $sdate['2']);
		
			$sql = "SELECT * FROM blog_visits WHERE ip='".$this -> db ->Escape($ip)."' AND page_id='".$page_id."' AND time>".$time_start."  ";
	    	$res = $this -> db -> Exec($sql);
			$row= $this -> db -> fetch($res);
		
			if(!$row['id']) {
				$sql = "INSERT IGNORE blog_visits (ip,page_id,time) VALUES ('".$ip."','".$page_id."','".time()."')";   
				$res = $this -> db -> Exec($sql);							 												
			}	
	
	}
	

	
	public function getItem ($id,$front_end=0) { 
		$id = (int) $id;
		
		$products = new Products();
		$and_sql = '';
		$sql = "SELECT * FROM blog_pages WHERE 1=1 ".$and_sql." AND id=".$id."  ";
		
		//echo $sql;
		$current_lang = $this->L->getCurrentLanguage();
		
    	$res = $this -> db -> Exec($sql);
		$row= $this -> db -> fetch($res);
		
		
		if(!empty($row)) {	
								
				if($row['status']==1)
					$row['status_name'] = $this->L->Str('active');
				elseif($row['status']==0)
					$row['status_name'] = $this->L->Str('not_active');

				$row['title_ru']=$row['title'];					
				$row['title_lv']=$this->L->StrT_lang('blog_pages','title', $row['id'],'','lv');
				$row['title_en']=$this->L->StrT_lang('blog_pages','title', $row['id'],'','en');
				
				$row['text_ru']=$row['text'];					
				$row['text_lv']=$this->L->StrT_lang('blog_pages','text', $row['id'],'','lv');
				$row['text_en']=$this->L->StrT_lang('blog_pages','text', $row['id'],'','en');
				
				$row['blog_image'] = '/images/blog_images/'.$row['image'];   
				
				$row['title'] = $row['title_'.$current_lang];
		        $row['text'] = html_entity_decode($row['text_'.$current_lang]);
		        
		       	$short_description = strip_tags($row['text']);
		  		$row['short_desc'] = strlen($short_description)>520 ?  mb_substr(strip_tags($short_description),0,520,'UTF8').'...' : $short_description;
			
		}
		
		$data = $row;
	
				
		
		$sql = "SELECT g.measure,g.new,g.price_old,g.free_shipping,l.translation,p.`product_id` as id,g.price,g.price_2,power FROM  seo_products as p LEFT JOIN goods as g ON g.id = p.product_id LEFT JOIN languages_texts as l ON l.objectid=g.id AND lang='lv' AND col='title' AND type='goods'  WHERE p.page_id=".$data['id'];
		
		//echo $sql;
		$res = $this -> db -> Exec($sql);		    
	    $prods = array();

		$rows = $this -> db -> Count($res);
		if ($rows) {
			for ($i=0;$i<$rows;$i++) {
				$row = $this -> db -> fetch($res);
				
			    if($row['price_old']>0 && $row['price_2']>0)
					 $discount = round(100-(($row['price_2']/$row['price_old'])*100));   
				else
					$discount = 0;	 
				$row['discount'] = $discount;	
				$row['title'] = $row['translation']; 				
				$row['thumb'] = WEBURL2.$products->getThumbnail($row['id'],'t');
				$row['bigpic'] = WEBURL2.$products->getThumbnail($row['id'],'');
				$row['price'] = (float) $row['price'];
				$row['price_2'] = (float) $row['price_2'];
				$row['saved_money'] = $products-> calcProfit($row['power']); 
				$row['buyofftime'] = $products-> calcbuyOff($row['saved_money'],$row['price']);              
															               			               						
				$prods[$row['id']] = $row;
			}	
		}
		
		$data['products'] = $prods;
		
	/*	$sql = "SELECT g.title,l.translation,p.`category_id` as id,g.`image`,g.parentid,g.position FROM  blog_categories as p LEFT JOIN goods_categories as g ON g.id = p.category_id LEFT JOIN languages_texts as l ON l.objectid=g.id AND lang='lv' AND col='title' AND type='goods_categories'  WHERE p.page_id=".$data['id'].' ORDER BY g.position ASC';
		
		//echo $sql;
		$res = $this -> db -> Exec($sql);		                   
	    $cats = array();

		$rows = $this -> db -> Count($res);
		if ($rows) {
			for